
class common {

  public static float DOT(vector3 A, vector3 B) {
    return A.x * B.x + A.y * B.y + A.z * B.z;
  }
  
  public static void NORMALIZE(vector3 A) {
    double l = 1.0 / Math.sqrt(A.x * A.x + A.y * A.y + A.z * A.z);
  
    A.x *= l;
    A.y *= l;
    A.z *= l;
  }
  
  public static float LENGTH(vector3 A) {
    return (float) Math.sqrt(A.x * A.x + A.y * A.y + A.z * A.z);
  }
  
  public static float SQRLENGTH(vector3 A) {
    return A.x * A.x + A.y * A.y + A.z * A.z;
  }
  
  public static float SQRDISTANCE(vector3 A, vector3 B) {
    return (A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y) + (A.z - B.z) * (A.z - B.z);
  }


  public final static float EPSILON = 0.001f;
  public final static int TRACEDEPTH = 6;

  public final static double PI = 3.141592653589793238462;
}

