class Material {
  public Material() {
    m_Color.Set( 0.2f, 0.2f, 0.2f );
    m_Refl = 0f;
    m_Diff = 0.2f;
    m_Spec = 0.8f;
    m_RIndex = 1.5f;
  }
  public void SetColor( Color a_Color ) {
    m_Color = a_Color;
  }
  public Color GetColor() {
    return m_Color;
  }
  public void SetDiffuse( float a_Diff ) {
    m_Diff = a_Diff;
  }
  public void SetSpecular( float a_Spec ) {
    m_Spec = a_Spec;
  }
  public void SetReflection( float a_Refl ) {
    m_Refl = a_Refl;
  }
  public void SetRefraction( float a_Refr ) {
    m_Refr = a_Refr;
  }
  public float GetSpecular() {
    return m_Spec;
  }
  public float GetDiffuse() {
    return m_Diff;
  }
  public float GetReflection() {
    return m_Refl;
  }
  public float GetRefraction() {
    return m_Refr;
  }
  public void SetRefrIndex( float a_Refr ) {
    m_RIndex = a_Refr;
  }
  public float GetRefrIndex() {
    return m_RIndex;
  }

  private Color m_Color = new Color();
  private float m_Refl, m_Refr;
  private float m_Diff, m_Spec;
  private float m_RIndex;
}

