import java.awt.image.*;
import java.awt.*;
import javax.swing.*;

class Painting extends JPanel {
  BufferedImage image;  // declare the image

  public void setImage(BufferedImage image) {
    this.image = image;
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);       // paint background
    if (image != null) {
      Graphics2D g2 = (Graphics2D)g; // we need a Graphics2D context
    
      // Draw the grid from the precomputed image
      g2.drawImage(image, null, 0, 0);
    }
  }
}
        